Subject: Re: [bug#48325] julia-1.6 guix

From: Nicolò Balzarotti <[email-masked]>
Date: Tue, 11 May 2021 12:18:40 +0200

zimoun <[email-masked]> writes:

> Hi,
>
> On Tue, 11 May 2021 at 11:18, Nicolò Balzarotti <[email-masked]> wrote:
>> zimoun <[email-masked]> writes:
>
>>> Please, split this patch.  One per update, i.e., 5 patches I guess.
>>
>> Some changes should probably be committed together since current julia
>> will fail to build with newer deps versions, but at least for utf8proc
>> I'm sure this can be splitted.
>
> The issue is that the update of pcre2 is a ’core-updates’ change, IIUC:
>
>   guix refresh -l pcre2
>
> so the package cannot be simply updated.  This one also should be
> splitted, IMHO.
>
> Is the current [email-masked] ’will fail’ for sure or probably ’would fail’
> with [email-masked] and [email-masked]?  I have not tried
> yet. :-)
>
>
>>>> +         (add-before 'install 'symlink-libraries
>>>
>>> [...]
>>>
>>>> +               (link "zlib" "usr/lib/julia/" "libz\\.so")
>>>
>>> Does this fix
>>>
>>>    <http://issues.guix.gnu.org/48238>
>>>
>>> ?
>>> Does it make sense?
>>>
>> I just tried running
>>> cd /gnu/store/fp5by15552ihyppxppigmbxs981rd08h-julia-1.6.1
>>> find -type f -exec grep '/tmp/guix-build-julia-1.5.3.drv-0' {} \;
>>
>> and it returns nothing.  Also, your Pkg.add("GZip"); using GZip worked
>
> Cool!
>
>> (but it printed
>>
>> ┌ Error: curl_easy_setopt: 48
>> └ @ Downloads.Curl
>> ~/guix-build-julia-1.6.1.drv-0/julia-1.6.1/usr/share/julia/stdlib/v1.6/Downloads/src/Curl/utils.jl:36
>>
>> which might be worth investigating)
>
> Thanks for trying and reporting.  Did you use a --pure or --container
> environment?

Nope, I just changed home with
> HOME=/tmp julia
I tried with a container now:

./pre-inst-env guix environment --ad-hoc julia nss-certs --container
export SSL_CERT_DIR=$GUIX_ENVIRONMENT/etc/ssl/certs/
export SSL_CERT_FILE=$GUIX_ENVIRONMENT/etc/ssl/certs/ca-certificates.crt
export GIT_SSL_CAINFO="$SSL_CERT_FILE"
julia  -e 'using Pkg; Pkg.add("GZip"); using GZip'

Same error
┌ Error: curl_easy_setopt: 48
└ @ Downloads.Curl /tmp/guix-build-julia-1.6.1.drv-0/julia-1.6.1/usr/share/julia/stdlib/v1.6/Downloads/src/Curl/utils.jl:36

But GZip works (I tried the example on the homepage:
import GZip

fh = GZip.open("infile.gz")
s = readline(fh)

close(fh))

> Well, ‘guix size glibc-locales’ reports ~922MiB.  Although this package
> is probably already on the store, I would prefer to avoid to add it as
> an input.  Currently, ’guix size julia’ says ~1080MiB.  How much with
> the glibc-locales as inputs?

./pre-inst-env guix size julia
1205.6 MiB

glibc-locales does not appear in the closure size (I attached the
output).

The biggest change seams to lie in Julia itself (~+130Mb)